; fpuSUXX
; Oyd11, April 2003
; http://oyd11.planet-d.net
;
; KBD to change BG col
;
; No, I have nothing against the FPU, and I rather enjoy stack computing
; I wish I had the P-II ops though (fcmps) I'm working on a P200
;
; TODO: !! Try to use FSCALE!!! mulby 2**st0 !!!
;
; 124byte, 'wylder' version..

	ORG 0x100 ;; .com file

	mov al,0x13 ;; Set V mode (320x200x8bit)
	int 0x10

	push word 0xa000
	pop es

;	fninit ;; hmmm.. cheap...

	fld dword [delta] ; time
	fld st0 ; delta,time
;	fild word [scaleBy] ; scaleBy,delta,time
	fldl2t ;

	mov ax,cs

;	mov dx,0x1000
;	add ax,dx

	add ax,0x1000 ; skip 64k
	mov ds,ax ; ds -> backbuff
;; ds-> buff, es-> vidmem


MainLoop


	;mov dx,1024 ; int counter... should be about pi/delta
	; or 3.14 / 0.003 =~ 1024
	mov dx,3210
; 	mov dh,4 ; another byte
	;; TODO:: CHK y crashs on '8' for exmpale...
	;; (Sadly on 6,5 also :/ r we just lucky on '4' ??)


	; CLS:
;	mov bx,64000 - 4
;	xor bx,bx ; save a byte, lose some time..
;	xor ax,ax

.cls
	mov [si],al ; kewl gray bg (kdb col)
;	mov [si],ah ; orange bg
;	mov [si],bl ; 'tight' colouring
;	mov [si],bh ; rainbow colours
;	mov [si],cl ; black
	dec si ; gotta be in the 'other' direction from buff copy ;)
	jnz .cls
	;; ^^^ Use si to move img left, di to move right,
	;; bx to not move, but not CLS every few rounds...

	;; reset accumulator to 'delta'
	fld st1 ; acc,scale,delta,t


draw:
	;; draw parametric curve:
	fadd st2 ; acc,scale,delta,t

	; r=f(phy),
	; for example: scale *= sin(3acc);
	fldl2t ; almost 3..
	fmul st1 ; 3acc,acc,scale,delta,t
	         ;  0   1    2     3    4
	fadd st4 ; 3acc+t,acc,scale,delta,time
			 ; 0       1    2    3    4   

	fsin     ; sin(t+3acc),acc,scale,delta,t
	fmul st2 ; sin3acc*scale,acc,scale,delta,t
	         ;   0            1   2     3    4

	fld st1 ; acc,r,acc,scaleBy,delta,t
			;  0  1  2   3      4     5

	fsincos  ; cos,sin,r,acc,scale,delta,t
			 ; 0   1   2   3    4   5    6

	fmul st2 ; rCos,sin,r,3acc,acc,scale,delta
	fxch st2 ; r,sin,rCos...
	fmulp st1 ; rSin,RCos,acc,sc,delt,t
			  ;  0   1     2    3  4   5

; 'altering the curve a bit' :

;	fld st2
;; ^^ just load

	fldpi
;; mul by pi
;	fldl2t

;	fldl2e
;	fmul st0
	;; mul by 2.?
;	fld1
;	fadd st0
;; mul by 2

	fmul st3

	fsincos ; cos,sin,rcos,rsin,acc,sc,delt,t
	        ;  0  1   2    3    4   5  6    7 ; outta stack :/
	

	faddp st3,st0 ; ssin,rsin+scos,rcos,acc,sc,delt,t
	             ;  0    1          2   3   4   5
	faddp st2,st0 ; rsin+scos,rcos+ssin,acc,sc,delt,t
                  ;   0            1     2  3   4   5

	fldl2t 
	fmul st0
	fadd st0  ; =~ 22

	fmul st1,st0 ; mul both by 22
	fmulp st2

	; 80s+20c = (4s+c)*20 ... hmmm ... let's try..

	;;; Now put pixel, at (st0,st1)
	fistp qword [bx]
	fistp word [si] ; just put it 'somewhere'
	;; choose varsize to set line width... ;)
	;; Can't we pop FPU to a CPU reg?
		; acc,scale,delta
		     ; ready to loop (FPU state..)

	; just put the pixel now...:
	mov ax,[bx]
	add ax,100 ; mid screen

	mov bh,al
	xor bl,bl ; bx=y*256

 	shl ax,6 ; ax = y*64
	add bx,ax ; bx = 320*y
	
	add bx,[si] ; bx = pixel offset
;	mov [fs:bx],cl ; put a pixel
;; We put a pixel on the next round, while storing tmp ycoord...

	dec dx
	jnz draw
	
	;; Copy to VRAM:
	dec cx
	rep movsb

	; make time go forward:
	
	; acc,sc,del,t
	;  0  1  2   3

	fldlg2 ; trying to save 2 bytes for not storing deltat..
	fdiv st1
	faddp st4

	fstp st0 ; pop accumulator to ret fpu state..

	in al,0x60  ; read kbd
;	cmp al,1    ; cmp w/ <esc>
	dec al
	jne MainLoop

	mov ax,3
	int 0x10
	ret

;; Vars:
;; 'experimental' values:
time ; delta is preloaded only, later can be used, since it's a valid float
delta dd 0.003
;scaleBy dw 22
;scale2 dw 20
;time dd 0.0
;deltat dd 0.055

;section .bss
;xcoord resw 1
;ycoord resw 1

